﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using Dapper;
using System.Collections;
using Dapper.Contrib.Extensions;

namespace Dapper.Test
{
    /*
     * 创建数据库person
     * 创建表 Teacher Student (Dapper.Test脚本文件夹里面有创建表脚本)
     * 修改下面链接字符串
     */
    class Program
    {
        static string connectionString = "Data Source=ADMIN-PC;Initial Catalog=person;Integrated Security=false;User ID=sa;Password=123456";
        //static string connectionString1 = @"Data Source=WIN-L8TOD2M74CD\SQLEXPRESS;Initial Catalog=person;Integrated Security=false;User ID=sa;Password=123456";
        static void Main(string[] args)
        {
            IDbConnection conn = new SqlConnection(connectionString);

            #region Dapper.Contrib
            //using (conn)
            //{
            //    conn.Open();
            //    var t11 = conn.Get<Teacher>("916a84c6-85cb-4b41-b52a-96a0685d91b5");
            //    Teacher t12 = new Teacher()
            //    {
            //        Id = Guid.NewGuid().ToString(),
            //        Name = "h12",
            //        Sex = Sex.Boy,
            //        Level = 'B',
            //        Age = 26
            //    };
            //    var t13 = conn.Insert<Teacher>(t12);
            //    t11.Age = 100;
            //    var t14 = conn.Update(t11);
            //}

            //Console.WriteLine("OK");
            //System.Threading.Thread.Sleep(1000);
            //return; 
            #endregion

            #region Dapper
            Teacher teacher = new Teacher();
            Student student = new Student();
            string sql = "";
            int intResult = 0;

            using (conn)
            {
                conn.Open();
                sql = "select * from student";// where Id='916a84c6-85cb-4b41-b52a-96a0685d91b5'";
                var sex = SqlMapper.Query<Dictionary<string, object>>(conn, sql, null).ToList();


                //删除
                sql = "delete from Teacher where Sex=#Sex#";
                intResult = SqlMapper.Execute(conn, sql, Sex.Boy);


                sql = "delete from Student where Id=#Id# and Name=@Name and Name=@Name1";
                Hashtable dic = new Hashtable();
                dic.Add("Id", "123");
                dic.Add("Name", "s1234");
                dic.Add("Name1", "d12345");
                intResult = SqlMapper.Execute(conn, sql, dic);
                sql = "delete from Teacher";
                intResult = SqlMapper.Execute(conn, sql, null);

                sql = "delete from Student";
                intResult = SqlMapper.Execute(conn, sql, null);
                sql = "delete from Teacher";
                intResult = SqlMapper.Execute(conn, sql, null);

                //插入
                //Teacher
                sql = "insert into Teacher(Id,Name,Sex) values(#Id#,#Name#,#Sex#)";
                string tid = Guid.NewGuid().ToString();
                teacher = new Teacher()
                {
                    Id = tid,
                    Name = "wang",
                    Sex = Sex.Girl
                };
                intResult = SqlMapper.Execute(conn, sql, teacher);

                //Student
                sql = "insert into Student(Id,Name,Tid) values(@Id,@Name,@Tid)";
                student = new Student()
                {
                    Id = Guid.NewGuid().ToString(),
                    Name = "wang",
                    Tid = tid
                };
                intResult = SqlMapper.Execute(conn, sql, student);
                sql = "insert into Student(Id,Name,Tid) values(@Id,@Name,@Tid)";
                student = new Student()
                {
                    Id = Guid.NewGuid().ToString(),
                    Name = "hao",
                    Tid = tid
                };
                intResult = SqlMapper.Execute(conn, sql, student);


                //查询
                sql = "select * from Teacher";
                var list = SqlMapper.Query<Teacher>(conn, sql, null).ToList();


                sql = "select * from Teacher left join Student on Teacher.Id=Student.Tid";
                //一对一
                var list1 = SqlMapper.Query<Teacher, Student, Teacher>(conn, sql,
                    (t, s) =>
                    {
                        if (t.Student == null) t.Student = new List<Student>();
                        t.Student.Add(s);
                        return t;
                    }
                    , null, true, null, "Id", null, null);
                //一对多
                Dictionary<string, Teacher> list2Dict = new Dictionary<string, Teacher>();//这个才是最后的结果
                var list2 = SqlMapper.Query<Teacher, Student, Teacher>(conn, sql,
                    (t, s) =>
                    {
                        Teacher temp;
                        if (!list2Dict.TryGetValue(t.Id, out temp))
                        {
                            temp = t;
                            list2Dict.Add(temp.Id, temp);
                        }
                        if (temp.Student == null) temp.Student = new List<Student>();
                        temp.Student.Add(s);
                        return temp;
                    }
                    , null, true, null, "Id", null, null);


                ////存储过程
                //SqlMapper.Execute(conn, "test", null, null, null, CommandType.StoredProcedure);

                //事务
                using (IDbTransaction trans = conn.BeginTransaction())
                {
                    try
                    {
                        sql = "delete from Student";
                        intResult = SqlMapper.Execute(conn, sql, null, trans, null, null);
                        sql = "delete from Teacher";
                        intResult = SqlMapper.Execute(conn, sql, null, trans, null, null);

                        sql = "insert into Teacher(Id,Name) values(@Id,@Name)";
                        string tid1 = Guid.NewGuid().ToString();
                        teacher = new Teacher()
                        {
                            Id = tid1,
                            Name = "事务插入"
                        };
                        intResult = SqlMapper.Execute(conn, sql, teacher, trans, null, null);

                        throw new Exception("回滚测试");
                        trans.Commit();
                    }
                    catch
                    {
                        trans.Rollback();
                    }
                }
            }
            #endregion

            Console.WriteLine("OK");
            System.Threading.Thread.Sleep(1000);
            //Console.ReadKey();
        }
    }





    public enum Sex
    {
        None,
        Boy,
        Girl
    }
    public class Teacher
    {
        [Key]
        public string Id { get; set; }
        public string Name { get; set; }
        public Sex Sex { get; set; }
        public char Level { get; set; }
        public int Age { get; set; }
        [Ignore]
        public IList<Student> Student { get; set; }
    }
    public class Student
    {
        public string Id { get; set; }
        public string Tid { get; set; }
        public string Name { get; set; }
    }

    /// <summary>
    /// 暂不支持结构体
    /// </summary>
    public struct StudentStruct
    {
        public string Id { get; set; }
        public string Tid { get; set; }
        public string Name { get; set; }
    }
}
